package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.dao.custom.base.impl.FindConverterDao;
import com.jasamedika.medifirst2000.entities.PapSirkulasi;
import com.jasamedika.medifirst2000.vo.PapSirkulasiVO;

/**
 * Converter class PAPSirkulasi
 * 
 * @author Askur
 */
@Component
public class PapSirkulasiConverter extends FindConverterDao implements
		BaseVoConverter<PapSirkulasiVO, PapSirkulasi> {

	public PapSirkulasi transferVOToModel(PapSirkulasiVO vo, PapSirkulasi model) {
		if (null == model)
			model = new PapSirkulasi();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, PapSirkulasi.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;

	}

	public List<PapSirkulasiVO> transferListOfModelToListOfVO(List<PapSirkulasi> models,
			List<PapSirkulasiVO> vos) {
		if (null == vos)
			vos = new ArrayList<PapSirkulasiVO>();

		if (null == models)
			return vos;

		for (PapSirkulasi model : models) {
			PapSirkulasiVO vo = new PapSirkulasiVO();
			transferModelToVO(model, vo);
			vos.add(vo);
		}

		return vos;
	}

	public PapSirkulasiVO transferModelToVO(PapSirkulasi model, PapSirkulasiVO vo) {
		if (null == vo)
			vo = new PapSirkulasiVO();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, PapSirkulasiVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return vo;
	}
	
}
